org.apache.lucene.analysis.standard

## Class StandardTokenizer

- java.lang.Object
- - org.apache.lucene.util.AttributeSource
  - - org.apache.lucene.analysis.TokenStream
    - - org.apache.lucene.analysis.Tokenizer
      - - org.apache.lucene.analysis.standard.StandardTokenizer

- All Implemented Interfaces:
    Closeable, AutoCloseable

      public final class StandardTokenizer
      extends Tokenizer

  A grammar-based tokenizer constructed with JFlex.

  This class implements the Word Break rules from the Unicode Text Segmentation algorithm, as specified in Unicode Standard Annex #29.

  Many applications have specific tokenizer needs. If this tokenizer does not suit your application, please consider copying this source code directory to your project and maintaining your own grammar-based tokenizer.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.lucene.util.AttributeSource

      `AttributeSource.State`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `ACRONYM` Deprecated. (3.1)
    `static int` | `ACRONYM_DEP` Deprecated. (3.1)
    `static int` | `ALPHANUM` Alpha/numeric token type
    `static int` | `APOSTROPHE` Deprecated. (3.1)
    `static int` | `CJ` Deprecated. (3.1)
    `static int` | `COMPANY` Deprecated. (3.1)
    `static int` | `EMAIL` Email token type
    `static int` | `HANGUL` Hangul token type
    `static int` | `HIRAGANA` Hiragana token type
    `static int` | `HOST` Deprecated. (3.1)
    `static int` | `IDEOGRAPHIC` Idiographic token type
    `static int` | `KATAKANA` Katakana token type
    `static int` | `MAX_TOKEN_LENGTH_LIMIT` Absolute maximum sized token
    `static int` | `NUM` Numeric token type
    `static int` | `SOUTHEAST_ASIAN` Southeast Asian token type
    `static String[]` | `TOKEN_TYPES` String token types that correspond to token type int constants

    - ### Fields inherited from class org.apache.lucene.analysis.Tokenizer

      `input`

    - ### Fields inherited from class org.apache.lucene.analysis.TokenStream

      `DEFAULT_TOKEN_ATTRIBUTE_FACTORY`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `StandardTokenizer()` Creates a new instance of the `StandardTokenizer`.
    `StandardTokenizer(AttributeFactory factory)` Creates a new StandardTokenizer with a given `AttributeFactory`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Releases resources associated with this stream.
    `void` | `end()` This method is called by the consumer after the last token has been consumed, after `TokenStream.incrementToken()` returned `false` (using the new `TokenStream` API).
    `int` | `getMaxTokenLength()` Returns the current maximum token length
    `boolean` | `incrementToken()` Consumers (i.e., `IndexWriter`) use this method to advance the stream to the next token.
    `void` | `reset()` This method is called by a consumer before it begins consumption using `TokenStream.incrementToken()`.
    `void` | `setMaxTokenLength(int length)` Set the max allowed token length.

    - ### Methods inherited from class org.apache.lucene.analysis.Tokenizer

      `correctOffset, setReader`

    - ### Methods inherited from class org.apache.lucene.util.AttributeSource

      `addAttribute, addAttributeImpl, captureState, clearAttributes, cloneAttributes, copyTo, endAttributes, equals, getAttribute, getAttributeClassesIterator, getAttributeFactory, getAttributeImplsIterator, hasAttribute, hasAttributes, hashCode, reflectAsString, reflectWith, removeAllAttributes, restoreState, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### ALPHANUM

          public static final int ALPHANUM

      Alpha/numeric token type
      See Also:
        Constant Field Values

    - #### APOSTROPHE

          @Deprecated
          public static final int APOSTROPHE

      Deprecated. (3.1)
      See Also:
        Constant Field Values

    - #### ACRONYM

          @Deprecated
          public static final int ACRONYM

      Deprecated. (3.1)
      See Also:
        Constant Field Values

    - #### COMPANY

          @Deprecated
          public static final int COMPANY

      Deprecated. (3.1)
      See Also:
        Constant Field Values

    - #### EMAIL

          public static final int EMAIL

      Email token type
      See Also:
        Constant Field Values

    - #### HOST

          @Deprecated
          public static final int HOST

      Deprecated. (3.1)
      See Also:
        Constant Field Values

    - #### NUM

          public static final int NUM

      Numeric token type
      See Also:
        Constant Field Values

    - #### CJ

          @Deprecated
          public static final int CJ

      Deprecated. (3.1)
      See Also:
        Constant Field Values

    - #### ACRONYM_DEP

          @Deprecated
          public static final int ACRONYM_DEP

      Deprecated. (3.1)
      See Also:
        Constant Field Values

    - #### SOUTHEAST_ASIAN

          public static final int SOUTHEAST_ASIAN

      Southeast Asian token type
      See Also:
        Constant Field Values

    - #### IDEOGRAPHIC

          public static final int IDEOGRAPHIC

      Idiographic token type
      See Also:
        Constant Field Values

    - #### HIRAGANA

          public static final int HIRAGANA

      Hiragana token type
      See Also:
        Constant Field Values

    - #### KATAKANA

          public static final int KATAKANA

      Katakana token type
      See Also:
        Constant Field Values

    - #### HANGUL

          public static final int HANGUL

      Hangul token type
      See Also:
        Constant Field Values

    - #### TOKEN_TYPES

          public static final String[] TOKEN_TYPES

      String token types that correspond to token type int constants

    - #### MAX_TOKEN_LENGTH_LIMIT

          public static final int MAX_TOKEN_LENGTH_LIMIT

      Absolute maximum sized token
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### StandardTokenizer

          public StandardTokenizer()

      Creates a new instance of the `StandardTokenizer`. Attaches the `input` to the newly created JFlex scanner. See http://issues.apache.org/jira/browse/LUCENE-1068

    - #### StandardTokenizer

          public StandardTokenizer(AttributeFactory factory)

      Creates a new StandardTokenizer with a given `AttributeFactory`

  - ### Method Detail

    - #### setMaxTokenLength

          public void setMaxTokenLength(int length)

      Set the max allowed token length. Tokens larger than this will be chopped up at this token length and emitted as multiple tokens. If you need to skip such large tokens, you could increase this max length, and then use `LengthFilter` to remove long tokens. The default is `StandardAnalyzer.DEFAULT_MAX_TOKEN_LENGTH`.
      Throws:
        `IllegalArgumentException` - if the given length is outside of the range [1, 1048576].

    - #### getMaxTokenLength

          public int getMaxTokenLength()

      Returns the current maximum token length
      See Also:
        `setMaxTokenLength(int)`

    - #### incrementToken

          public final boolean incrementToken()
                                       throws IOException

      Description copied from class: `TokenStream`
      Consumers (i.e., `IndexWriter`) use this method to advance the stream to the next token. Implementing classes must implement this method and update the appropriate `AttributeImpl`s with the attributes of the next token.

      The producer must make no assumptions about the attributes after the method has been returned: the caller may arbitrarily change it. If the producer needs to preserve the state for subsequent calls, it can use `AttributeSource.captureState()` to create a copy of the current attribute state.

      This method is called for every token of a document, so an efficient implementation is crucial for good performance. To avoid calls to `AttributeSource.addAttribute(Class)` and `AttributeSource.getAttribute(Class)`, references to all `AttributeImpl`s that this stream uses should be retrieved during instantiation.

      To ensure that filters and consumers know which attributes are available, the attributes must be added during instantiation. Filters and consumers are not required to check for availability of attributes in `TokenStream.incrementToken()`.

      Specified by:
        `incrementToken` in class `TokenStream`
      Returns:
        false for end of stream; true otherwise
      Throws:
        `IOException`

    - #### end

          public final void end()
                         throws IOException

      Description copied from class: `TokenStream`
      This method is called by the consumer after the last token has been consumed, after `TokenStream.incrementToken()` returned `false` (using the new `TokenStream` API). Streams implementing the old API should upgrade to use this feature.

      This method can be used to perform any end-of-stream operations, such as setting the final offset of a stream. The final offset of a stream might differ from the offset of the last token eg in case one or more whitespaces followed after the last token, but a WhitespaceTokenizer was used.

      Additionally any skipped positions (such as those removed by a stopfilter) can be applied to the position increment, or any adjustment of other attributes where the end-of-stream value may be important.

      If you override this method, always call `super.end()`.

      Overrides:
        `end` in class `TokenStream`
      Throws:
        `IOException` - If an I/O error occurs

    - #### close

          public void close()
                     throws IOException

      Description copied from class: `Tokenizer`
      Releases resources associated with this stream.

      If you override this method, always call `super.close()`, otherwise some internal state will not be correctly reset (e.g., `Tokenizer` will throw `IllegalStateException` on reuse).

      NOTE: The default implementation closes the input Reader, so be sure to call `super.close()` when overriding this method.

      Specified by:
        `close` in interface `Closeable`
      Specified by:
        `close` in interface `AutoCloseable`
      Overrides:
        `close` in class `Tokenizer`
      Throws:
        `IOException`

    - #### reset

          public void reset()
                     throws IOException

      Description copied from class: `TokenStream`
      This method is called by a consumer before it begins consumption using `TokenStream.incrementToken()`.

      Resets this stream to a clean state. Stateful implementations must implement this method so that they can be reused, just as if they had been created fresh.

      If you override this method, always call `super.reset()`, otherwise some internal state will not be correctly reset (e.g., `Tokenizer` will throw `IllegalStateException` on further usage).

      Overrides:
        `reset` in class `Tokenizer`
      Throws:
        `IOException`

Copyright © 2000-2018 Apache Software Foundation. All Rights Reserved.